guide/urls.py
from django.urls import path

from guide import views
from guide.views import GuideListView, GuideDetailView, GuideCreateView, GuideItemCreateView

app_name = 'guide'

urlpatterns = [
    path('add', GuideCreateView.as_view(), name='create_guide'),
    path('add_item', GuideItemCreateView.as_view(), name='create_guide_item'),
    path('<int:guide_id>/', GuideDetailView.as_view(), name='guide'),
    path('<int:guide_id>/<int:character_id>', GuideDetailView.as_view(), name='guide'),
    path('', GuideListView.as_view(), name='guides_list'),
]

poe_guides/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.contrib.staticfiles.urls import staticfiles_urlpatterns
from django.urls import path, include

urlpatterns = [
    path('admin/', admin.site.urls),
    path('user/', include('user.urls')),
    path('guide/', include('guide.urls')),
    *staticfiles_urlpatterns(),
    *static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)



]

user/urls.py
from django.urls import path
from user import views

app_name = 'user'

urlpatterns = [
    path('signup/', views.signup_view, name='signup'),
    path('login/', views.login_view, name='login'),
    path('logout/', views.logout_view, name='logout'),
]

guide/models.py
from django.contrib.auth.models import User
from django.db import models
from ckeditor.fields import RichTextField
import re


class GuideItem(models.Model):
    slug = models.SlugField(unique=True, allow_unicode=True)
    name = models.CharField(max_length=100, blank=True, null=True)
    baseType = models.CharField(max_length=200)
    ilvl = models.CharField(max_length=100)
    icon = models.CharField(max_length=500,
                            default='https://web.poecdn.com/gen/image/WzI1LDE0LHsiZiI6IjJESXRlbXMvUmluZ3MvUmluZzYiLCJ3IjoxLCJoIjoxLCJzY2FsZSI6MX1d/74a5d719fd/Ring6.png')
    identified = models.BooleanField()
    implicitMods = models.TextField(blank=True, null=True)
    explicitMods = models.TextField(blank=True, null=True)
    utilityMods = models.TextField(blank=True, null=True)
    craftedMods = models.TextField(blank=True, null=True)
    enchantMods = models.TextField(blank=True, null=True)
    fracturedMods = models.TextField(blank=True, null=True)

    def __str__(self):
        return f' {self.name}||{self.baseType}'

    def save(self, force_insert=False, force_update=False, using=None, update_fields=None):
        if not self.slug:
            if not self.name:
                self.slug = f'{self.baseType}'
            else:
                self.slug = f'{self.name} {self.baseType}'
        super().save(force_insert, force_update, using, update_fields)


class Guide(models.Model):
    name = models.CharField(max_length=500)
    league = models.CharField(max_length=500)
    guide_text = RichTextField(blank=True, null=True)
    icon = models.ImageField(blank=True, null=True, default='harvest-logo.jpg')
    creator = models.ForeignKey(User, null=True, blank=True, default=None, on_delete=models.SET_NULL)
    create_at = models.DateField(auto_now_add=True)
    recommended_items = models.ManyToManyField(GuideItem)

    def text_definition(self):
        self.guide_text = str(self.guide_text).replace('&nbsp;', ' ').replace('&#39;', "'")
        item_replace = re.findall('\$.*?\$', str(self.guide_text))

        for item in item_replace:
            name = re.findall('\$(.*)\$', item)
            try:
                item_from_build = GuideItem.objects.get(slug=name[0])
                self.guide_text = str(self.guide_text).replace(item, f'<div class="someitem"> {item_from_build.baseType}'
                                                                     f'<div class="someitem__hidden">'
                                                                     f'<img src="{item_from_build.icon}">'
                                                                     f'<p>Name : <span>{item_from_build.name}</span></p>'
                                                                     f'<p>Base type : <span>{item_from_build.baseType}</span>'
                                                                     f'</p><p>ItemLvL : <span>{item_from_build.ilvl}</span></p>'
                                                                     f'</div>'
                                                                     f'</div>')
            except:
                item_from_build = name[0]
                self.guide_text = str(self.guide_text).replace(item, f'<div class="someitem"> {item_from_build}'
                                                                     f'<div class="someitem__hidden">'
                                                                     f'<p>Name : <span>{item_from_build}</span></p>'
                                                                     f'</div>'
                                                                     f'</div>')
        return self.guide_text

guide/forms.py
from django import forms
from guide.models import GuideItem, Guide
from ckeditor.fields import RichTextField

class GuideItemForm(forms.ModelForm):
    name = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'Item name', 'class': 'form__inp__default'}))
    baseType = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'baseType', 'class': 'form__inp__default'}))
    ilvl = forms.IntegerField(widget=forms.TextInput(attrs={'placeholder': 'ilvl', 'class': 'form__inp__default'}))
    icon = forms.ImageField(widget=forms.TextInput(attrs={'placeholder': 'Img URL', 'class': 'form__inp__default'}))
    implicitMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'implicitMods', 'class': 'form__inp__default'}))
    explicitMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'explicitMods', 'class': 'form__inp__default'}))
    utilityMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'utilityMods', 'class': 'form__inp__default'}))
    craftedMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'craftedMods', 'class': 'form__inp__default'}))
    enchantMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'enchantMods', 'class': 'form__inp__default'}))
    fracturedMods = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'fracturedMods', 'class': 'form__inp__default'}))


    class Meta:
        model = GuideItem
        fields = ('name', 'baseType', 'ilvl', 'icon', 'identified', 'implicitMods', 'explicitMods', 'utilityMods',
                  'craftedMods', 'enchantMods', 'fracturedMods')


class GuideForm(forms.ModelForm):
    name = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'Guide name', 'class': 'form__inp__default'}))
    league = forms.CharField(widget=forms.TextInput(attrs={'placeholder': 'League', 'class': 'form__inp__default'}))
    icon = forms.ImageField()
    guide_text = RichTextField()
    class Meta:
        model = Guide
        fields = ('name', 'league', 'guide_text', 'recommended_items')

guide/views.py
import requests
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render, redirect

# Create your views here.
from django.views.generic import ListView, DetailView, CreateView

from guide.forms import GuideForm, GuideItemForm
from guide.models import Guide, GuideItem
from user.models import Character, Item, Character_Class


# function for update heroes
def heroes_update(user):
    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, ke Gecko) Chrome/61.0.3163.100 Safari/537.36'}
    response = requests.get(f'https://www.pathofexile.com/character-window/get-characters?accountName={user.username}',
                            headers=headers)
    data = response.json()
    user_characters = Character.objects.filter(account=user)
    character_names = []
    for character in data:
        character_names.append(character['name'])
        if Character.objects.filter(name=character['name']):
            Character.objects.filter(name=character['name']).update(league=character['league'],
                                                                    level=character['level'])
        else:
            character_data = Character(
                name=character['name'],
                league=character['league'],
                character_class=Character_Class.objects.get(pk=character['classId']),
                level=character['level'],
                account=user
            )
            character_data.save()
    for character in user_characters:
        if character.name not in character_names:
            character.delete()


# function for update inventory
def update_inventory(character_id, username):
    headers = {
        'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, ke Gecko) Chrome/61.0.3163.100 Safari/537.36'}
    response = requests.get(
        f'https://www.pathofexile.com/character-window/get-items?accountName={username}&character={Character.objects.get(pk=character_id).name}',
        headers=headers)
    data = response.json()
    updated_items = data['items']
    updated_items_id = [item_id['id'] for item_id in updated_items]
    chatacter_items = [item.item_id for item in list(Item.objects.filter(character_items=character_id))]
    for item in updated_items:
        if Item.objects.filter(item_id=item['id']):
            Item.objects.filter(item_id=item['id']).update(name=item.get('name'),
                                                           baseType=item.get('baseType'),
                                                           ilvl=item.get('ilvl'),
                                                           icon=item.get('icon'),
                                                           identified=item.get('identified'),
                                                           implicitMods=item.get('implicitMods'),
                                                           explicitMods=item.get('explicitMods'),
                                                           utilityMods=item.get('utilityMods'),
                                                           craftedMods=item.get('craftedMods'),
                                                           enchantMods=item.get('enchantMods'),
                                                           fracturedMods=item.get('fracturedMods'),
                                                           corrupted=item.get('corrupted'))
        else:
            item_data = Item(
                item_id=item.get('id'),
                name=item.get('name'),
                baseType=item.get('baseType'),
                ilvl=item.get('ilvl'),
                icon=item.get('icon'),
                identified=item.get('identified'),
                implicitMods=item.get('implicitMods'),
                explicitMods=item.get('explicitMods'),
                utilityMods=item.get('utilityMods'),
                craftedMods=item.get('craftedMods'),
                enchantMods=item.get('enchantMods'),
                fracturedMods=item.get('fracturedMods'),
                corrupted=item.get('corrupted'),
                character_items=Character.objects.get(pk=character_id))
            item_data.save()

    for item in chatacter_items:
        if item not in updated_items_id:
            item.delete()


class GuideItemCreateView(LoginRequiredMixin, CreateView):
    model = GuideItem
    form_class = GuideItemForm
    template_name = 'create_guide_item.html'
    login_url = 'user:login'

    def form_valid(self, form):
        guide_item = f'{self.request.POST.get("name")}'
        if GuideItem.objects.filter(name=guide_item):
            error = "Item alredy exist"
            return render(self.request, 'create_guide_item.html', context={'form': form, 'error': error})

        else:
            guide_item = f'{self.request.POST.get("baseType")}'
            if GuideItem.objects.filter(baseType=guide_item):
                error = "Item alredy exist"
                return render(self.request, 'create_guide_item.html', context={'form': form, 'error': error})
        form.save()
        return super().form_valid(form)


class GuideCreateView(LoginRequiredMixin, CreateView):
    model = Guide
    form_class = GuideForm
    template_name = 'create_guide.html'
    login_url = 'user:login'

    def form_valid(self, form):
        guide_name = self.request.POST.get("name")
        if Guide.objects.filter(name=guide_name):
            error = 'Guide already exist'
            return render(self.request, 'create_guide.html', context={'form': form, 'error': error})
        new_guide = form.save(commit=False)
        new_guide.creator = self.request.user
        new_guide.save()
        form.save_m2m()
        return super().form_valid(form)


class GuideListView(ListView):
    model = Guide
    ordering = ['-create_at']
    template_name = 'guides_list.html'


class GuideDetailView(LoginRequiredMixin, DetailView):
    model = Guide
    template_name = 'guide.html'
    login_url = 'user:login'
    pk_url_kwarg = 'guide_id'

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        guide_id = self.kwargs.get('guide_id')
        character_id = self.kwargs.get('character_id')
        guide = Guide.objects.get(pk=guide_id)
        user = self.request.user
        heroes_update(user)
        characters = Character.objects.filter(account=user)
        guide.text_definition()

        if character_id:
            self.template_name = 'guide_hero.html'
            guide_items = [item.name for item in guide.recommended_items.all()]
            update_inventory(character_id, self.request.user)
            character_items = list(Item.objects.filter(character_items=character_id))
            items = []
            for item in character_items:
                if item.name in guide_items:
                    items.append(item)
            context['guide'] = guide
            context['characters'] = characters
            context['items'] = items
            return context
        context['guide'] = guide
        context['characters'] = characters

        return context

guide/templates/create_guide.html
{% extends 'base.html' %}
{% load static %}


  {% block static %}
  <title>Create guide</title>
  {% endblock %}


  {% block content %}
<form action="{% url 'guide:create_guide' %}" method="POST" enctype="multipart/form-data">
    {% csrf_token %}
      <p class="form__title">Guide creation</p>
      <div class="form__inputs">
          {{ form.name }}
          {{ form.league }}
        <div class="form__img__load">
          <p>Choose image</p>
            {{ form.icon }}
        </div>
        <div class="form__add_text">
          {{ form.media}}
          {{ form.guide_text }}
        </div>
        <div class="form__add__item">{{ form.recommended_items }}</div>
        <button class="ready" type="submit">Create</button>
      </div>

</form>
  {% endblock %}

guide/templates/create_guide_item.html
{% extends 'base.html' %}
{% load static %}


  {% block static %}
  <title>Create guide</title>
  {% endblock %}


  {% block content %}

<form action="{% url 'guide:create_guide_item' %}" method="POST" enctype="multipart/form-data">
    {% csrf_token %}
      <p class="form__title">Item creation</p>
      <div class="form__inputs">
          {{ form.name }}
          {{ form.baseType }}
          {{ form.ilvl }}
        <div class="form__img__load">
          <p>Choose image</p>
            {{ form.icon }}
          <p>Identified {{ form.identified }}</p>
        </div>
          {{ form.implicitMods }}
          {{ form.explicitMods }}
          {{ form.utilityMods }}
          {{ form.craftedMods }}
          {{ form.enchantMods }}
          {{ form.fracturedMods }}
        {% if error %}
        <p>{{error}}</p>
         {% endif %}
        <button class="ready" type="submit">Create</button>
      </div>

</form>
  {% endblock %}

guide/templates/guide.html
{% extends 'base.html' %}
{% load static %}


  {% block static %}
  <title>{{ guide.name }}</title>
  {% endblock %}


  {% block content %}

    <main>
      <div class="container">
        <div class="main__content">
          <div class="content__left">
            <div class="build">
              <h1 class="build__name">{{ guide.name }}</h1>
              <img class="build__img" src="{{ guide.icon.url }}" alt="build-img">
              <div class="build__desc">
                {{ guide.guide_text|safe }}
              </div>
            </div>
          </div>
          <div class="content__right">
            <div class="heroes">
              <p class="heroes__title">Characters</p>
              {% for character in characters %}
              <div class="heroes__item">
                <a href="{% url 'guide:guide' guide_id=guide.id character_id=character.id %}">
                  <div class="heroes__img">
                    <img src="{{ character.character_class.icon }}" alt="img">
                    <p class="heroes__info">Name : <span>{{ character.name }}</span></p>
                    <p class="heroes__info">League : <span>{{ character.league }}</span></p>
                    <p class="heroes__info">Level : <span>{{ character.level }}</span></p>
                    <p class="heroes__info">Class : <span>{{ character.character_class.name|capfirst }}</span></p>
                  </div>
                </a>
              </div>
              {% endfor %}

            </div>
          </div>
        </div>
      </div>
    </main>
    </div>
    <script src="js/main.js?v=1.0"></script>
  {% endblock %}

guide/templates/guide_hero.html
{% load static %}
<html>
<head>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" href="{% static 'css/style.css' %}" />
<meta charset="UTF-8">
<title>SomeTitle</title>
</head>
  <body>
    <div class="body-wrapper">

    <header>
      <img src="{% static 'img/header-icon.png' %}" alt="header-img" class="header__left">
      <img src="{% static 'img/header-icon.png' %}" class="header__right">
      <nav>
        <ul>
          <li><a href="{% url 'guide:guides_list' %}">Builds</a></li>
          <li><a href="{% url 'guide:create_guide' %}">Add Build</a></li>
          <li><a href="{% url 'guide:create_guide_item' %}">Add Item</a></li>
        </ul>
      </nav>
    </header>

      <main>
        <div class="container">
            <div class="hero__block">
              <h1 class="hero__block__title">{{ character.name}}</h1>
              <div class="hero__items">
                <h2>Items you already have</h2>
                {% for item in items %}
                <p>{{item}}</p>
                {% endfor %}
              </div>
            </div>
          </div>
      </main>
    </div>
  </body>
</html>

guide/templates/guides_list.html
{% extends 'base.html' %}
{% load static %}

  {% block static %}
    <title>Guide</title>
  {% endblock %}
<div class="body-wrapper">

{% block content %}
<div class="container">
      <div class="builds__block">
        <h1>Builds</h1>
        <div class="builds">
            {% for guide in guide_list %}
          <div class="builds__item">
            <a href="{% url 'guide:guide' guide_id=guide.id %}">
                {% if guide.icon %}
              <img src="{{ guide.icon.url }}" alt="build-img">
                {% endif %}
              <p class="builds__item__name">{{ guide.name }}</p>
              <p class="Builds__item__data">{{ guide.create_at }}</p>
            </a>
          </div>
            {% endfor %}
      </div>
      </div>
    </div>
</div>
</div>
    <script src="js/main.js?v=1.0"></script>
  {% endblock %}